# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b101"
os.chdir("/Users/wstein/.sage/sage_notebook/worksheets/admin/273/cells/4")
sage.server.notebook.interact.SAGE_CELL_ID=4
_sage_const_2 = Integer(2); _sage_const_1 = Integer(1)
class RealComponentGroup:
    """
    The real component group of `J_0(N)` as an `\GF{2}` vector space.
    """
    def __init__(self, N):
        self._N = N

    @cached_method
    def vector_space(self):
        M = ModularSymbols(self._N)
        H = M.cuspidal_submodule().integral_structure()
        d = H.rank()//_sage_const_2
        S = M.star_involution().matrix().restrict(H).change_ring(ZZ)
        W = M.atkin_lehner_operator(N).matrix().restrict(H)
        W2 = matrix(GF(_sage_const_2 ),W.nrows(),W.list())  # awkward because of bug
        S2 = matrix(GF(_sage_const_2 ),S.nrows(),S.list())
        A2 = (S2-_sage_const_1 ).kernel()
        A0 = (S-_sage_const_1 ).kernel()
        return A2 / A0.change_ring(GF(_sage_const_2 ))

print "e101"
