# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b147"
os.chdir("/Users/wstein/.sage/sage_notebook/worksheets/admin/273/cells/4")
sage.server.notebook.interact.SAGE_CELL_ID=4
_sage_const_2 = Integer(2); _sage_const_1 = Integer(1)
class RealComponentGroup:
    """
    The real component group of `J_0(N)` as an `\GF{2}` vector space.
    """
    def __init__(self, N):
        self._N = N

    def __repr__(self):
        return "Component group of J0(%s)(R), which has dimension %s"%(self._N,
                self.vector_space().dimension())

    @cached_method
    def vector_space(self):
        M = ModularSymbols(self._N)
        self._M = M
        H = M.cuspidal_submodule().integral_structure()
        self._H = H
        d = H.rank()//_sage_const_2
        S = M.star_involution().matrix().restrict(H).change_ring(ZZ)
        S2 = matrix(GF(_sage_const_2 ),S.nrows(),S.list())
        A2 = (S2-_sage_const_1 ).kernel()
        A0 = (S-_sage_const_1 ).kernel()
        return A2 / A0.change_ring(GF(_sage_const_2 ))

    def atkin_lehner(self, q):
        V = self.vector_space()
        M = self._M
        H = self._H
        W = M.atkin_lehner_operator(q).matrix().restrict(H)
        W = matrix(GF(_sage_const_2 ),W.nrows(),W.list())
        print W
        ims = [V(V.lift(x)*W) for x in V.gens()]
        return V.hom(ims)

print "e147"
